<?php

namespace Drupal\tone\Plugin\ToneAttachmentStrategy;

use Drupal\tone\AttachmentStrategyPluginBase;

/**
 * Plugin implementation of the tone_attachment_strategy.
 *
 * @ToneAttachmentStrategy(
 *   id = "tone_css_inline",
 *   label = @Translation("CSS Inline"),
 *   description = @Translation("Adds a style tag to the HTML head.")
 * )
 */
class CssInline extends AttachmentStrategyPluginBase {

  /**
   * {@inheritdoc}
   */
  public function attach(array $build, string $identifier, string $source): array {
    $styleTag = [
      '#tag' => 'style',
      '#value' => $source,
    ];

    $build['#attached']['html_head'][] = [
      $styleTag,
      'tone_css_inline-' . $identifier,
    ];

    return $build;
  }

}
